#!/bin/sh

awk '
# Modify X and Y to make a nicer map.  We turn the map upside down (since 
# North and South are relative and can be flipped) as well as moving it left
# so the international date line doesnt bisect a continent

# Hard-coded for a particular map 
# Trivia: Awks function syntax is the model used by Javascript
function Xm(x) {
        x -= 29 # Shift left
        if(x < 0) {x+=144}
        return 143-x} 
function Ym(y) {
        return 95-y} 


{
# Starting locations
if(/StartingX=([0-9]+), StartingY=([0-9]+)/) {
        x=$0;
        sub(/.*StartingX=/,"",x);sub(/,.*/,"",x);
        y=$0;sub(/.*StartingY=/,"",y);
        x = Xm(x);y = Ym(y);
        $0 = "\tStartingX=" x ", StartingY=" y
        }
# Map tiles
if(/x=([0-9]+),y=([0-9]+)/) {
        x=$0;
        sub(/.*x=/,"",x);sub(/,.*/,"",x);
        y=$0;sub(/.*y=/,"",y);
        x = Xm(x);y = Ym(y);
        $0 = "\tx=" x ",y=" y
        }
# Print modified map
print
}'         
